import { select, schemeSpectral, schemeCategory10, scaleOrdinal, json, tsv, geoPath, geoNaturalEarth1, zoom, event } from 'd3';
import {colorLegend} from './colorLegend';
import {loadAndProcessData} from './loadAndProcessData';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);









const g = svg.append('g')



const colorLegendG = svg.append('g')
.attr('transform',`translate(30,300)`)


g.append('path')
.attr('class','sphere')
.attr('d', pathGenerator({type: 'Sphere'}));



svg.call(zoom().on('zoom',()=>{
g.attr('transform', d3.event.transform)
}))

const colorScale = scaleOrdinal(schemeSpectral[7])

const colorValue = d => d.properties.economy

loadAndProcessData().then(countries => {
  
  colorScale
    .domain(countries.features.map(colorValue))
    .domain(colorScale.domain().sort().reverse())  
.range(schemeSpectral[colorScale.domain().length]);
  
  
  colorLegendG
.call(colorLegend,{
  colorScale,  
  circleRadius: 8,
  spacing: 20,
  textOffset: 20,
    backgroundRectWidth: 250
});
  
  
  const paths = g.selectAll('path')
  .data(countries.features);
  
  paths.enter().append('path')
  .attr('class','country')
  .attr('d', d=>pathGenerator(d))
  .attr('fill', d=>colorScale(colorValue(d)))
  .append('title')
  .text(d=>d.properties.name + ': ' + colorValue(d))

})




